#pragma once
#include "OpenGLRendererPick.h"

#include "Model.h"

class CModelViewerRenderer :
	public COpenGLRendererPick
{
public:
	CModelViewerRenderer();
	~CModelViewerRenderer();

	// oϐ
private:
public:
	CModel m_model;
	//GLubyte* m_abt4VertexIdColor;
	//GLubyte* m_abt4TriangleIdColor;
	unsigned int m_auiVboID[3];	// VBO ID
public:
	BOOL m_bRotation;
	BOOL m_bPan;
	BOOL m_bZoom;
	BOOL m_bRenderPoint;
	BOOL m_bRenderLine;
	BOOL m_bRenderFace;
	BOOL m_bPickPoint;
	BOOL m_bPickLine;
	BOOL m_bPickFace;

	// o֐
private:
	void	RenderModel( ERENDERMODE eRenderMode );
	void	IdentifyPickRegionPixels( unsigned int uiCountPickRegionPixel, unsigned int aauiNamePickRegionPixel[][NAMEARRAYSIZE] );
	//void	MakeArray();
	//void	DestroyArray();
	void	MakeVBO();
	void	DestroyVBO();
	unsigned int GetVertexIdColorVboID(){ return m_auiVboID[0]; }
	unsigned int GetTriangleIdColorVboID(){ return m_auiVboID[1]; }
	bool	InitializeOpenGL( HWND hWnd );
public:
	void	UninitializeOpenGL( HWND hWnd );
	bool	DoTracking( POINT point );
};

